using System;
using System.Windows.Forms;
using System.Drawing;
using System.Runtime.InteropServices;
using System.IO;
using System.Xml.Serialization;


namespace ADX_OL_Serialization_CS
{
    /// <summary>
    /// Summary description for ADXOlForm1.
    /// </summary>
    public class ADXOlForm1 : AddinExpress.OL.ADXOlForm
    {
        private Label label1;
        private Label label2;
        private Label label3;
        private Label label4;
        private Label label5;
        private System.ComponentModel.IContainer components = null;

        public ADXOlForm1()
        {
            // This call is required by the Windows Form Designer.
            InitializeComponent();

            // TODO: Add any initialization after the InitializeComponent call

        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                if (components != null)
                {
                    components.Dispose();
                }
            }
            base.Dispose(disposing);
        }

        #region Designer generated code
        /// <summary>
        /// Required method for Designer support - do not modify
        /// the contents of this method with the code editor.
        /// </summary>
        private void InitializeComponent()
        {
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.SuspendLayout();
            // 
            // label1
            // 
            this.label1.AutoSize = true;
            this.label1.Location = new System.Drawing.Point(32, 31);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(30, 13);
            this.label1.TabIndex = 1;
            this.label1.Text = "ID = ";
            // 
            // label2
            // 
            this.label2.AutoSize = true;
            this.label2.Location = new System.Drawing.Point(32, 58);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(47, 13);
            this.label2.TabIndex = 2;
            this.label2.Text = "Name = ";
            // 
            // label3
            // 
            this.label3.AutoSize = true;
            this.label3.Location = new System.Drawing.Point(32, 87);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(81, 13);
            this.label3.TabIndex = 3;
            this.label3.Text = "Discontinued = ";
            // 
            // label4
            // 
            this.label4.AutoSize = true;
            this.label4.Location = new System.Drawing.Point(32, 118);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(47, 13);
            this.label4.TabIndex = 4;
            this.label4.Text = "Count = ";
            // 
            // label5
            // 
            this.label5.AutoSize = true;
            this.label5.Location = new System.Drawing.Point(32, 146);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(42, 13);
            this.label5.TabIndex = 5;
            this.label5.Text = "Date = ";
            // 
            // ADXOlForm1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(300, 300);
            this.Controls.Add(this.label5);
            this.Controls.Add(this.label4);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.Name = "ADXOlForm1";
            this.Text = "ADXOlForm1";
            this.ADXBeforeFormShow += new AddinExpress.OL.ADXOlForm.BeforeFormShow_EventHandler(this.ADXOlForm1_ADXBeforeFormShow);
            this.ResumeLayout(false);
            this.PerformLayout();

        }
        #endregion



        private void ADXOlForm1_ADXBeforeFormShow()
        {
            Boolean success = false;
            Outlook.Inspector inspector = InspectorObj as Outlook.Inspector;
            if (inspector != null)
            {
                Outlook.MailItem item = (Outlook.MailItem)inspector.CurrentItem;
                if (item != null)
                    try
                    {
                        if (!item.Sent)
                        {
                            this.Visible = false;
                            return;
                        }
                        if (item.Attachments.Count > 0)
                        {
                            for (int i = 1; i <= item.Attachments.Count; i++)
                            {
                                string TempFileTmp = Path.GetTempFileName();
                                string TempFileXml = Path.ChangeExtension(TempFileTmp, "xml");
                                if (File.Exists(TempFileTmp))
                                {
                                    File.Delete(TempFileTmp);
                                }
                                item.Attachments.Item(i).SaveAsFile(TempFileXml);
                                try
                                {
                                    AddinModule.DataClass newObj;
                                    FileStream fileStream = new FileStream(TempFileXml, FileMode.Open);
                                    try
                                    {
                                        XmlSerializer newSerializer = new XmlSerializer(typeof(AddinModule.DataClass));
                                        newObj = (AddinModule.DataClass)newSerializer.Deserialize(fileStream);
                                        label1.Text = "ID = " + newObj.ID;
                                        label2.Text = "Name = " + newObj.Name;
                                        label3.Text = "Discontinued = " + newObj.Discontinued.ToString();
                                        label4.Text = "Count = " + newObj.Count.ToString();
                                        label5.Text = "Date = " + newObj.Date.ToString();
                                        success = true;
                                    }
                                    finally
                                    {
                                        fileStream.Close();
                                    }
                                }
                                catch
                                {
                                    // skip exception (serialization)
                                }
                                File.Delete(TempFileXml);
                                if (success) break;
                            }
                        }
                        if (!success)
                        {
                            this.Visible = false;
                            return;
                        }
                    }
                    finally
                    {
                        Marshal.ReleaseComObject(item);
                        item = null;
                    }
            }
        }

    }
}

